import type { GroupVO, GroupForm, GroupQuery } from './model';

import type { ID, IDS } from '#/api/common';
import type { PageResult } from '#/api/common';

import { commonExport } from '#/api/helper';
import { requestClient } from '#/api/request';

/**
* 查询群列表
* @param params
* @returns 群列表
*/
export function groupList(params?: GroupQuery) {
  return requestClient.get<PageResult<GroupVO>>('/im/group/list', { params });
}

/**
 * 导出群列表
 * @param params
 * @returns 群列表
 */
export function groupExport(params?: GroupQuery) {
  return commonExport('/im/group/export', params ?? {});
}

/**
 * 查询群详情
 * @param id id
 * @returns 群详情
 */
export function groupInfo(id: ID) {
  return requestClient.get<GroupVO>(`/im/group/${id}`);
}

/**
 * 新增群
 * @param data
 * @returns void
 */
export function groupAdd(data: GroupForm) {
  return requestClient.postWithMsg<void>('/im/group', data);
}

/**
 * 更新群
 * @param data
 * @returns void
 */
export function groupUpdate(data: GroupForm) {
  return requestClient.putWithMsg<void>('/im/group', data);
}

/**
 * 删除群
 * @param id id
 * @returns void
 */
export function groupRemove(id: ID | IDS) {
  return requestClient.deleteWithMsg<void>(`/im/group/${id}`);
}
